/*
 * RotateToPrincipalAxisSystemAction.hpp
 *
 *  Created on: May 10, 2010
 *      Author: heber
 */

#ifndef ROTATETOPRINCIPALAXISSYSTEMACTION_HPP
#define ROTATETOPRINCIPALAXISSYSTEMACTION_HPP

#include "Actions/Action.hpp"
#include "Actions/Process.hpp"

class MoleculeListClass;
class Vector;

void MoleculeRotateToPrincipalAxisSystem(Vector &Axis);

class MoleculeRotateToPrincipalAxisSystemAction : public Action {
  friend void MoleculeRotateToPrincipalAxisSystem(Vector &Axis);

public:
  MoleculeRotateToPrincipalAxisSystemAction();
  virtual ~MoleculeRotateToPrincipalAxisSystemAction();

  bool canUndo();
  bool shouldUndo();

  virtual const std::string getName();
protected:
  virtual Dialog * fillDialog(Dialog *dialog);
private:
  virtual Action::state_ptr performCall();
  virtual Action::state_ptr performUndo(Action::state_ptr);
  virtual Action::state_ptr performRedo(Action::state_ptr);

  static const char NAME[];
};


#endif // ROTATETOPRINCIPALAXISSYSTEMACTION_HPP
